_TITLE "eRATication no 3 by bplus 2018-07-15"
'QB64 version 2017 1106/82 (the day before they switched to version 1.2)

' 2018-07-13 modified from Asteroids game
' 2018-07-15 eRATication 2
' color rats, eliminate jerks when kill rat,
' decrease rat size as life progresses
' 2018-07-15 some minor changes since post of e #2
' 2018-07-20 eRATication 3
' Shooter: location controlled by mouse
'          mouse left and right button works like left and right arrow keys.
' Code: use type for objects, simplify math where possible
'       complete makeover of code.
'       Fixed problem of running into burning rat.
' Display: Life # and Points on screen as Fellippe suggested.
' Points: should be directly proportional to rat's speed and indirectly
'          proportional to size, so speed\size!
'          but compare that to number of shots taken!


'================================ Instructions ==========================
' Up and down arrows for fast rotation of shooter.
' Left and right arrows for more fine tuned rotation of shooter.
' Shooter is connected to mouse, moving mouse moves shooter.
' Left mouse button down for counter-clock wise rotation and
' Right mouse button down for clock- wise rotation.
' Spacebar fires bullets.
'========================================================================

DEFINT A-Z

'screen dimensions
CONST wW = 1200
CONST wH = 700

CONST ratPack = 5
CONST nBullets = 1000
CONST bSpeed = 20
CONST maxLife = 3

TYPE bullet
    x AS INTEGER
    y AS INTEGER
    dx AS INTEGER
    dy AS INTEGER
    live AS INTEGER
END TYPE

TYPE rat
    x AS INTEGER
    y AS INTEGER
    r AS INTEGER
    dx AS INTEGER
    dy AS INTEGER
    c AS _UNSIGNED LONG
    dead AS INTEGER
END TYPE

SCREEN _NEWIMAGE(wW, wH, 32)
_SCREENMOVE 100, 20
RANDOMIZE TIMER

DIM SHARED shooterA, shooterX, shooterY, life, nRats, fire, points, GameOn, newRound, shots
DIM SHARED b(nBullets) AS bullet, r(maxLife * ratPack) AS rat

shooterX = wW / 2
shooterY = wH / 2
shooterA = 0
life = 1
nRats = life * ratPack
points = 0
GameOn = 1
newRound = 0
shots = 0
FOR i = 0 TO nRats
    newRat i
NEXT

_MOUSEHIDE
WHILE GameOn
    CLS
    newRound = 0

    'Now for some seriously nice control!!!
    WHILE _MOUSEINPUT: WEND
    shooterX = _MOUSEX: shooterY = _MOUSEY
    IF _MOUSEBUTTON(1) THEN shooterA = (shooterA - 5) MOD 360
    IF _MOUSEBUTTON(2) THEN shooterA = (shooterA + 5) MOD 360

    '    _KEYDOWN WORKS NICE!!!!
    'use arrow keys to swing shooter, spacebar to fire
    IF _KEYDOWN(19200) THEN shooterA = (shooterA - 5) MOD 360
    IF _KEYDOWN(19712) THEN shooterA = (shooterA + 5) MOD 360
    IF _KEYDOWN(18432) THEN shooterA = (shooterA - 15) MOD 360
    IF _KEYDOWN(20480) THEN shooterA = (shooterA + 15) MOD 360
    IF _KEYDOWN(32) THEN fire = 1: shots = shots + 1 ELSE fire = 0
    IF _KEYDOWN(27) THEN END
    drawshooter
    handleRats
    IF newRound = 0 THEN handleBullets: stats
    _DISPLAY
    _LIMIT 30
WEND
_DELAY 5 'so don't start printing spaces in the editor

SUB newRat (iRat)
    side = rand(1, 4)
    SELECT CASE side
        CASE 1
            r(iRat).x = 0: r(iRat).y = rand(0, wH)
            r(iRat).dx = rand(1, 6) * life: r(iRat).dy = rand(-4, 4) * life
        CASE 2
            r(iRat).x = wW: r(iRat).y = rand(0, wH)
            r(iRat).dx = rand(-6, -1) * life: r(iRat).dy = rand(-4, 4) * life
        CASE 3
            r(iRat).x = rand(0, wW): r(iRat).y = 0
            r(iRat).dx = rand(-6, 6) * life: r(iRat).dy = rand(1, 4) * life
        CASE 4
            r(iRat).x = rand(0, wW): r(iRat).y = wH:
            r(iRat).dx = rand(-6, 6) * life: r(iRat).dy = rand(-4, -1) * life
    END SELECT
    r(iRat).r = rand(10, 60 / life)
    r(iRat).dead = 0
    r = rand(60, 255): g = r \ 2 + rand(0, 20): b = g \ 2 + rand(0, 10)
    r(iRat).c = _RGB32(r, g, b)
END SUB

SUB drawshooter () 'simple red iso triangle pointed towards radianAngle
    'calculate 3 points of triangle shooter
    DIM rA AS SINGLE
    rA = _D2R(shooterA)
    x1 = shooterX + 60 * COS(rA) 'main point of shooter according to heading
    y1 = shooterY + 60 * SIN(rA)
    x2 = shooterX + 30 * COS(rA + _PI(2 / 3)) 'next two points are 120 degrees off main point in direction
    y2 = shooterY + 30 * SIN(rA + _PI(2 / 3))
    x3 = shooterX + 30 * COS(rA - _PI(2 / 3))
    y3 = shooterY + 30 * SIN(rA - _PI(2 / 3))
    fTri shooterX, shooterY, x1, y1, x2, y2, _RGB(255, 0, 0)
    fTri shooterX, shooterY, x1, y1, x3, y3, _RGB(255, 0, 0)
    ln x1, y1, x2, y2, _RGB32(255, 255, 128)
    ln x1, y1, x3, y3, _RGB32(255, 255, 128)
    ln x1, y1, shooterX, shooterY, _RGB32(255, 255, 128)
END SUB

SUB handleRats ()
    FOR i = 0 TO nRats
        IF r(i).dead = 0 THEN 'if rat not dead move it
            r(i).x = r(i).x + r(i).dx
            r(i).y = r(i).y + r(i).dy
        END IF

        'rat collides with shooter?
        IF ((r(i).x - shooterX) ^ 2 + (r(i).y - shooterY) ^ 2) ^ .5 < r(i).r + 4 AND r(i).dead = 0 THEN
            FOR rad = 1 TO 350
                fcirc shooterX, shooterY, rad, _RGB32(255 - .25 * rad, 128 - .25 * rad, 0)
                _DISPLAY
                _LIMIT 300
            NEXT
            IF life + 1 <= maxLife THEN
                life = life + 1
                nRats = life * ratPack
                newRound = 1
                'new set o rats
                FOR i = 0 TO nRats
                    newRat i
                NEXT
            ELSE
                GameOn = 0
            END IF
            EXIT SUB
        END IF

        'still here? is the rat on screen
        IF r(i).x > 0 AND r(i).x < wW AND r(i).y > 0 AND r(i).y < wH THEN 'inbounds
            IF r(i).dead THEN 'show the burn out until reaches rat radius
                r(i).dead = r(i).dead + 2
                IF r(i).dead < r(i).r THEN
                    fcirc r(i).x, r(i).y, r(i).r - r(i).dead, _RGB32(255 - r(i).dead, 128 - r(i).dead, 0)
                ELSE
                    newRat i
                END IF
            ELSE
                'draw it
                DIM heading AS SINGLE
                heading = _ATAN2(r(i).dy, r(i).dx)
                noseX = r(i).x + 2 * r(i).r * COS(heading)
                noseY = r(i).y + 2 * r(i).r * SIN(heading)
                neckX = r(i).x + .75 * r(i).r * COS(heading)
                neckY = r(i).y + .75 * r(i).r * SIN(heading)
                tailX = r(i).x + 2 * r(i).r * COS(heading + _PI)
                tailY = r(i).y + 2 * r(i).r * SIN(heading + _PI)
                earLX = r(i).x + r(i).r * COS(heading - _PI(1 / 12))
                earLY = r(i).y + r(i).r * SIN(heading - _PI(1 / 12))
                earRX = r(i).x + r(i).r * COS(heading + _PI(1 / 12))
                earRY = r(i).y + r(i).r * SIN(heading + _PI(1 / 12))
                fcirc r(i).x, r(i).y, .65 * r(i).r, r(i).c
                fcirc neckX, neckY, r(i).r * .3, r(i).c
                fTri noseX, noseY, earLX, earLY, earRX, earRY, r(i).c
                fcirc earLX, earLY, r(i).r * .3, r(i).c
                fcirc earRX, earRY, r(i).r * .3, r(i).c
                wX = .5 * r(i).r * COS(heading - _PI(11 / 18))
                wY = .5 * r(i).r * SIN(heading - _PI(11 / 18))
                ln noseX + wX, noseY + wY, noseX - wX, noseY - wY, r(i).c
                wX = .5 * r(i).r * COS(heading - _PI(7 / 18))
                wY = .5 * r(i).r * SIN(heading - _PI(7 / 18))
                ln noseX + wX, noseY + wY, noseX - wX, noseY - wY, r(i).c
                ln r(i).x, r(i).y, tailX, tailY, r(i).c
            END IF
        ELSE 'out of bounds
            newRat i
        END IF
    NEXT
END SUB

SUB handleBullets ()
    FOR i = 0 TO nBullets
        IF b(i).live = 0 AND fire = 1 THEN 'have in active bullet index to use
            DIM rA AS SINGLE
            rA = _D2R(shooterA)
            b(i).x = shooterX + 3 * bSpeed * COS(rA)
            b(i).y = shooterY + 3 * bSpeed * SIN(rA)
            b(i).dx = bSpeed * COS(rA)
            b(i).dy = bSpeed * SIN(rA)
            b(i).live = 1
            fire = 0
        END IF
        IF b(i).live = 1 THEN 'new location
            b(i).x = b(i).x + b(i).dx
            b(i).y = b(i).y + b(i).dy
            IF b(i).x > 0 AND b(i).x < wW AND b(i).y > 0 AND b(i).y < wH THEN 'in bounds draw it
                'check for collision with rat
                FOR r = 0 TO nRats
                    IF ((r(r).x - b(i).x) ^ 2 + (r(r).y - b(i).y) ^ 2) ^ .5 < r(r).r THEN
                        IF r(r).dead = 0 THEN
                            r(r).dead = 1
                            points = points + 5 * ((r(r).dx ^ 2 + r(r).dy ^ 2) ^ .5) / r(r).r
                            b(i).live = 0
                        END IF
                    ELSE
                        fcirc b(i).x, b(i).y, 2, _RGB32(255, 255, 0)
                    END IF
                NEXT
            ELSE
                b(i).live = 0
            END IF
        END IF
    NEXT
END SUB

SUB stats ()
    COLOR _RGB(200, 225, 255)
    _PRINTSTRING (5, 5), "Life #" + LTRIM$(STR$(life)) + "  Points:" + STR$(points) + "  Points divided by shots * 100 =" + STR$(100 * points / shots)
END SUB

FUNCTION rand% (lo%, hi%)
    rand% = INT(RND * (hi% - lo% + 1)) + lo%
END FUNCTION

' found at QB64.net:    http://www.qb64.net/forum/index.php?topic=14425.0
SUB fTri (x1, y1, x2, y2, x3, y3, K AS _UNSIGNED LONG)
    a& = _NEWIMAGE(1, 1, 32)
    _DEST a&
    PSET (0, 0), K
    _DEST 0
    _MAPTRIANGLE _SEAMLESS(0, 0)-(0, 0)-(0, 0), a& TO(x1, y1)-(x2, y2)-(x3, y3)
    _FREEIMAGE a& '<<< this is important!
END SUB

SUB ln (x1, y1, x2, y2, K AS _UNSIGNED LONG)
    LINE (x1, y1)-(x2, y2), K
END SUB

'Steve McNeil's  copied from his forum   note: Radius is too common a name
SUB fcirc (CX AS LONG, CY AS LONG, R AS LONG, c AS _UNSIGNED LONG)
    DIM subRadius AS LONG, RadiusError AS LONG
    DIM X AS LONG, Y AS LONG

    subRadius = ABS(R)
    RadiusError = -subRadius
    X = subRadius
    Y = 0

    IF subRadius = 0 THEN PSET (CX, CY), c: EXIT SUB

    ' Draw the middle span here so we don't draw it twice in the main loop,
    ' which would be a problem with blending turned on.
    LINE (CX - X, CY)-(CX + X, CY), c, BF

    WHILE X > Y
        RadiusError = RadiusError + Y * 2 + 1
        IF RadiusError >= 0 THEN
            IF X <> Y + 1 THEN
                LINE (CX - Y, CY - X)-(CX + Y, CY - X), c, BF
                LINE (CX - Y, CY + X)-(CX + Y, CY + X), c, BF
            END IF
            X = X - 1
            RadiusError = RadiusError - X * 2
        END IF
        Y = Y + 1
        LINE (CX - X, CY - Y)-(CX + X, CY - Y), c, BF
        LINE (CX - X, CY + Y)-(CX + X, CY + Y), c, BF
    WEND
END SUB

